#ifndef BIOS_H
#define BIOS_H

int biosprint(int pc);
int bios_init(void);

void bios_InitHeap(void *block, UINT32 size);
void *bios_malloc(UINT32 size);
void *bios_calloc(UINT32 size, UINT32 n);
void bios_free(void *ptr);
void *bios_realloc(void *ptr, UINT32 size);

int exception_handler();

#endif